import swarm.*;
import swarm.space.*;
import swarm.defobj.*;
import java.io.*;

public class CAWorld extends DblBuffer2dImpl {
	ObserverSwarm observer;
	int xsize, ysize; //Əc̃Z̐
	int prevReset; //Zbgpϐ(O̒lL^ĂAlς烊Zbg)
	int generation; //݂̐㐔

	public CAWorld(Zone aZone, ObserverSwarm ob){		
		super(aZone, ob.worldSizeX, ob.worldSizeY);
		observer = ob;
	}
	
	public Object setSizeX$Y(int x, int y){
		xsize = x;
		ysize = y;
		return this;
	}
	public Object setObserver(ObserverSwarm anObject){
		observer = anObject;
		return this;
	}
	
	public Object swapColorAtX$Y(int x, int y){
		int newState;
		int oldState = this.getValueAtX$Y(x,y);
		
		newState = (oldState == 1) ? 0 : 1;
		this.putValue$atX$Y(newState,x,y);
				
		return this;
	}
	
	public Object eraseAll(){
		int i,j;
		for(i=0;i<xsize;i++){
			for(j=0;j<ysize;j++){
				this.putValue$atX$Y(0,i,j);
			}
		}
		return this;
	}

	//AԂlȗŏ
	public Object init(){					
		generation = 0;
		for(int i = 0; i < xsize; i++){
			for(int j = 0; j < ysize; j++){
				int tmp = Globals.env.uniformIntRand.getIntegerWithMin$withMax(0, observer.paramN);
				this.putValue$atX$Y(tmp, i, j);
			}
		}
		this.updateLattice();
		return this;
	}
	
	//ԑJ
	public Object stepRule(){
		//ZI[g}g̃p[^
		int n = observer.paramN;
		int k1 = observer.paramK1;
		int k2 = observer.paramK2;
		int g = observer.paramG;
		
		//Zbg@\
		if (prevReset != observer.reset) {
			prevReset = observer.reset;
			init();
		}
		//ߗ׃ZlEFCg(cƉ̗vf͊łKv)
		int[][] neighborPattern = { //8̃p^[
			{1, 1, 1},
			{1, 1, 1},
			{1, 1, 1}
		};
		/*int[][] neighborPattern = { //iCg̃p^[
			{0, 1, 0, 1, 0},
			{1, 0, 0, 0, 1},
			{0, 0, 1, 0, 0},
			{1, 0, 0, 0, 1},
			{0, 1, 0, 1, 0}
		};*/
		int neighborPatternWidth = neighborPattern[0].length;
		int neighborPatternHeight = neighborPattern.length;

		//healthyillԂ̃Z̐B(Ot\Ɏg)
		double totalNumHealthy = 0;
		double totalNumIll = 0;
		
		//ԑJ
		for (int x = 0; x < xsize; x++)
		for (int y = 0; y < ysize; y++) {
			//̃Z̏Ԃ擾
			int state = this.getValueAtX$Y(x, y);
			
			//healthyillԂ̃Z̐𐔂
			if (state == n)
				totalNumIll++;
			else if (state == 0)
				totalNumHealthy++;
				
			//ߗ׃Z̏𓾂
			int numInfected = 0; //a
			int numIll = 0;      //b
			int sumState = 0;    //s
			for (int x2 = -neighborPatternWidth / 2; x2 <= neighborPatternWidth / 2; x2++)
			for (int y2 = -neighborPatternHeight / 2; y2 <= neighborPatternHeight / 2; y2++) {
				//EFCg擾
				int weight = neighborPattern[x2 + neighborPatternWidth / 2][y2 + neighborPatternHeight / 2];
				
				//ߗ׃Z̏Ԃ擾([͉肱݂)
				int neighbor = this.getValueAtX$Y((x + x2 + xsize) % xsize, (y + y2 + ysize) % ysize);
				
				//ɏ]āAa(numInfected), b(numIll), s(sumState)XV
				sumState += neighbor * weight;
				if (neighbor == n) //ill
					numIll += weight;
				else if (neighbor != 0) //healthy
					numInfected += weight;					
			}
				
			//߂ꂽɏ]ďԑJڂs
			if (state == n) //ill
				state = 0;
			else if (state != 0)  //infected
				state = sumState / (numInfected + numIll) + g; //̃z[y[WɏĂ̂ςȏł
			else //healthy
				state = numInfected / k1 + numIll / k2;
				
			//Ԓl͂ݏoOa
			if (state < 0)
				state = 0;
			else if (state > n)
				state = n;			
				
			//_uobt@̏ԂXV
			this.putValue$atX$Y(state, x, y);				
		}		
		
		//healthyillԂ̃Z̊t@Cɏo(Ot\p)		
		try {
			String fileName = "output.txt";		
			File file = new File(fileName);		
			PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(file, true)));
			pw.printf("%d,%.7f,%.7f\n", generation, 
				totalNumHealthy / (xsize * ysize), totalNumIll / (xsize * ysize));
			pw.close();
		}
		catch (Exception  e) {
			System.out.println(e);
		}
		
		//㐔CNg
		generation++;
		
		this.updateLattice();
		return this;
	}
}
