import swarm.simtoolsgui.*;
import swarm.gui.*;
import swarm.space.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.*;

public class ObserverSwarm extends GUISwarmImpl{
	public int displayFrequency;
	public int worldSizeX;
	public int worldSizeY;
	
	//ZI[g}g̃p[^
	public int paramN;
	public int paramK1;
	public int paramK2;
	public int paramG;
	
	//Zbgpϐ
	public int reset;
	
	ActionGroup displayActions; // schedule data structs
	Schedule displaySchedules;
	
	Colormap colorMap;
	ZoomRaster worldRaster;
	CAWorld world;
	
	Value2dDisplay valueDisplay;
	
	public ObserverSwarm(Zone aZone){
		// Superclass createBegin to allocate ourselves.
		super(aZone);
		
		// Fill in the relevant parameters
		displayFrequency = 1;
		worldSizeX = 300;
		worldSizeY = 300;
		
		//p[^̏
		paramN = 200;
		paramK1 = 2;
		paramK2 = 3;
		paramG = 30;
		
		EmptyProbeMap probeMap;
		probeMap = new EmptyProbeMapImpl(aZone, this.getClass());
		
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("displayFrequency", this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("worldSizeX", this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("worldSizeY", this.getClass()));
		
		//p[^̓o^
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("paramN", this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("paramK1", this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("paramK2", this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("paramG", this.getClass()));		
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("reset", this.getClass()));
		
		// Now install our custom proveMap into the probeLibrary.
		Globals.env.probeLibrary.setProbeMap$For(probeMap,this.getClass());
		
	}
	public Object buildObjects(){
		super.buildObjects();
		
		Globals.env.createArchivedProbeDisplay(this, "observerSwarm");
		
		getControlPanel().setStateStopped();
		
		// First, create a colormap: this is a global resource, the information			
		
		//J[}bv̐ݒ
		int numState = paramN;
		colorMap = new ColormapImpl(this);
		colorMap.setColor$ToRed$Green$Blue((byte)0, 0, 1, 0); //healty͗
		colorMap.setColor$ToRed$Green$Blue((byte)numState, 1, 0, 0); //ill͐
		for (int i = 1; i < numState; i++) { //infected͐(l傫قǐF𖾂邭)
			double a = 1.0 * (i - 1) / (numState - 2);
			colorMap.setColor$ToRed$Green$Blue((byte)i, 0, 0, a);	
		}
		
		System.out.println(numState);
		
		worldRaster = new ZoomRasterImpl(this);
		worldRaster.setColormap(colorMap);
		worldRaster.setZoomFactor(1);
		worldRaster.setWidth$Height(worldSizeX, worldSizeY);
		worldRaster.setWindowTitle("LGA's world");
		worldRaster.pack();
				
		world = new CAWorld(this, this);			
        world.setSizeX$Y(worldSizeX,worldSizeY);
		world.eraseAll();
		world.init();
		world.setObserver(this);
		
		try{
			valueDisplay = new Value2dDisplayImpl(this, worldRaster, colorMap, world);
		}catch(Exception e){
			System.err.println("Exception: " + e.getMessage());
			System.exit(1);
		}

		try{
			worldRaster.setButton$Client$Message(3, world, new Selector(world.getClass(), "swapColorAtX$Y",false));
		}catch(Exception e){
			System.err.println("Exception: " + e.getMessage());
			System.exit(1);
		}
		return this;
	}
	public Object buildActions(){
		
		// Create an ActionGroup for display
		displayActions = new ActionGroupImpl(this);
		
		// Schedule up the methods to draw the display of the world
		try{
			displayActions.createActionTo$message(valueDisplay, new Selector(valueDisplay.getClass(),"display",false));
			displayActions.createActionTo$message(worldRaster, new Selector(worldRaster.getClass(),"drawSelf",false));
			displayActions.createActionTo$message(world, new Selector(world.getClass(),"stepRule",false));
			displayActions.createActionTo$message(getActionCache(), new Selector(getActionCache().getClass(),"doTkEvents",true));
		}catch (Exception e){
			System.err.println("Exception: " + e.getMessage());
			System.exit(1);
		}
		displaySchedules = new ScheduleImpl(this, displayFrequency);
		displaySchedules.at$createAction(0,displayActions);
		
		return this;
	}
	
	public Activity activateIn(Swarm context){
		super.activateIn(context);
		
		// Now activate our schedule in ourselves.
		// This arranges for the excution of the schedule we built.
		
		displaySchedules.activateIn(this);
		
		// Activate returns the swarm activity
		
		return getActivity();
	}
	
	public Object eraseLGA(){
		if(world.getClass()!=null)
			world.eraseAll();
		return this;
	}
}